/*******************************************************************************
* Copyright (c) 2007 IONA Technologies PLC
* All rights reserved. This program and the accompanying materials
* are made available under the terms of the Eclipse Public License v1.0
* which accompanies this distribution, and is available at
* http://www.eclipse.org/legal/epl-v10.html
* 
* Contributors:
*     IONA Technologies PLC - initial API and implementation
*******************************************************************************/
package org.eclipse.stp.sc.cxf.generators;

import org.eclipse.core.resources.IFolder;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.stp.sc.jaxws.runtimeprovider.IProjectDirTemplate;

public class CeltixProjectDirTemplate implements IProjectDirTemplate {

	public static final String WSDL_FOLDER = "wsdl";
    public static final String SRC_FOLDER = "src";
    public static final String CLASSES_FOLDER = "classes";
	
	public IFolder getClassFolder(IProject project) {		
		return project.getFolder(CLASSES_FOLDER);
	}
	
	
	public IFolder getSrcDir(IProject project) {
		return project.getFolder(SRC_FOLDER);
	}
	
	/**
	 * since the source dir is fixed in cxf, do nothing in the set 
	 */
	public void setSrcDir(IFolder dir) {
		
	}

	public IFolder getWsdlDir(IProject project) {
		return project.getFolder(WSDL_FOLDER);
	}
	

	public void setInitializationData(IConfigurationElement config,
			String propertyName, Object data) throws CoreException {
		// TODO Auto-generated method stub

	}

}
